import { revertContext, setCurrentContext, getCurrentContext } from 'tfg-event-context';

var patch = function ($) {
  var $add = $.event.add;
  var $remove = $.event.remove;

  $.event.add = function (elem, types, handler, data, selector) {
    // console.log(elem, types, handler, data, selector);
    var ctx = getCurrentContext();
    if (!ctx) {
      return $add.call(this, elem, types, handler, data, selector);
    }

    var computation = function () {
      var args = [], len = arguments.length;
      while ( len-- ) args[ len ] = arguments[ len ];

      setCurrentContext(ctx);
      handler.__computation = computation;
      try {
        handler.call.apply(handler, [ this ].concat( args ));
      }
      finally {
        revertContext();
      }
    }

    ctx.addDisposable(
      function () {
        $remove(elem, types, computation, selector);
      }
    );

    return $add.call(this, elem, types, computation, data, selector);
  }

  $.event.remove = function (elem, types, handler, selector, mappedTypes) {
    if (typeof handler === 'function' && typeof handler.__computation === 'function') {
      return $remove.call(this, elem, types, handler.__computation, selector, mappedTypes);
    }
    return $remove.call(this, elem, types, handler, selector, mappedTypes);
  }
}

export { patch };